<template>
  <q-page class="q-pa-sm" style="min-height: 300px;">
    <div class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
    <template>
      <div class="q-pa-sm row items-center justify-center">
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.number" label="Numero" color="primary" :error="$v.form.number.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
      </div>
      <div class="q-pa-sm row items-center justify-center">
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.plant" label="Organización Nacional de Protección de:" color="primary" :error="$v.form.plant.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules autogrow v-model="form.address" label="Nombre y dirección de exportación" color="primary" :error="$v.form.address.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules autogrow v-model="form.consignee" label="Nombre y dirección de consignatario" color="primary" :error="$v.form.consignee.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.place" label="Pais de origen" color="primary" :error="$v.form.place.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.means" label="Medios de transporte" color="primary" :error="$v.form.means.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.entry" label="Punto de entrada" color="primary" :error="$v.form.entry.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.packages" label="Cantidad y descripción de paquetes" color="primary" :error="$v.form.packages.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.quantity" label="Nombre del producto y cantidad" color="primary" :error="$v.form.quantity.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input type="textarea" dense outlined rounded lazy-rules v-model="form.marks" label="Marca distintiva" color="primary" :error="$v.form.marks.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-select :options="options" dense outlined rounded lazy-rules v-model="form.botanical" label="Nombre de la planta" color="primary" :error="$v.form.botanical.$error" error-message="Dato necesario">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-select>
            </div>
          </div>
          <div class="row justify-center items-center">
            <div style="padding-right: 5px;" class="col-xs-12 col-sm-12 col-md-12 col-xl-12">
              <q-input dense outlined rounded lazy-rules autogrow v-model="form.declaration_aditional" label="Declaración adicional" color="primary">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
          </div>
          <div class="row justify-center items-center q-pa-md text-h6">Tratamiento de desinfectacción y/o desinfección</div>
          <br/>
          <div class="q-pa-md row justify-center items-center">
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input type="date" dense outlined rounded lazy-rules v-model="form.date_treatment" hint="Nombre de la planta" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.chemical" hint="Quimica" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.concentration" hint="Concentración" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.duration_temperature" hint="Duración y temperatura" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.treatment" hint="Tratamiento" color="secondary"/>
            </div>
          </div>
          <div class="row justify-center items-center">
            <div style="padding-right: 5px;" class="col-xs-12 col-sm-12 col-md-12 col-xl-12">
              <q-input dense outlined rounded lazy-rules autogrow v-model="form.aditional_information" hint="Declaración adicional" color="secondary">
                <q-tooltip>
                  Dato requerido *
                </q-tooltip>
              </q-input>
            </div>
          </div>
          <div class="row justify-center items-center q-pa-md text-h6">Uso exclusivo del mapa</div>
          <br/>
          <div class="q-pa-md row justify-center items-center">
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.place_of_issue" hint="Lugar de emision" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-input dense outlined rounded lazy-rules v-model="form.date_issue" type="date" hint="Fecha" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-5 col-md-3 col-xl-3">
              <q-select :options="names" dense outlined rounded lazy-rules v-model="form.name_authorized" hint="Nombre del Autorizador" color="secondary"/>
            </div>
            <div style="padding-right: 5px;" class="col-xs-10 col-sm-7 col-md-6 col-xl-6">
              <q-input autogrow disable dense outlined rounded lazy-rules placeholder="Assinado electronicamente / Electronically signed.  Consulta pelo site / Check using:\nhttps://sistemas.agricultura.gov.br/qrdocefito" hint="Cargo del oficial" color="secondary"/>
            </div>
          </div>
          <div>
          <div class="center">
            <vs-button
              block
              class="bg-primary"
              style="font-size: 12pt"
              @click="save"
            >
              <q-icon name="save"/> Guardar Datos
            </vs-button>
          </div>
          <br/>
          </div>
    </template>
    </div>
  </q-page>
</template>
<script>
import { date } from 'quasar'
const { addToDate } = date
import { required } from 'vuelidate/lib/validators'
export default {
  mounted () {
    this.$emit('setTittle', 'Nuevo Cliente')
    this.getInfo()
  },
  data () {
    return {
      form: {},
      id: '',
      actions: 'Guardar',
      options: [],
      names: [
        'JUAN MANUEL HERRERA MAST',
        'ANASTACIO LEVIMAR RODRIGUES PINHO',
        'VILSON OLIVEIRA SANTOS'
      ],
      states: [
        'ACRE / BRASIL',
        'ALAGOAS / BRASIL',
        'AMAPÁ / BRASIL',
        'AMAZONAS / BRASIL',
        'BAHÍA / BRASIL',
        'CEARÁ / BRASIL',
        'DISTRITO FEDERAL / BRASIL',
        'ESPÍRITO SANTO / BRASIL',
        'GOIÁS / BRASIL',
        'MARANHÃO / BRASIL',
        'MATO GROSSO / BRASIL',
        'MATO GROSSO DO SUL / BRASIL',
        'MINAS GERAIS / BRASIL',
        'PARÁ / BRASIL',
        'PARAÍBA / BRASIL',
        'PARANÁ / BRASIL',
        'PERNAMBUCO / BRASIL',
        'PIAUÍ / BRASIL',
        'RÍO DE JANEIRO / BRASIL',
        'RÍO GRANDE DO NORTE / BRASIL',
        'RÍO GRANDE DO SUL / BRASIL',
        'RONDÔNIA / BRASIL',
        'RORAIMA / BRASIL',
        'SANTA CATARINA / BRASIL',
        'SÃO PAULO / BRASIL',
        'SERGIPE / BRASIL',
        'TOCANTINS / BRASIL'
      ]
    }
  },
  validations: {
    form: {
      number: {
        required
      },
      plant: {
        required
      },
      address: {
        required
      },
      consignee: {
        required
      },
      place: {
        required
      },
      means: {
        required
      },
      entry: {
        required
      },
      packages: {
        required
      },
      quantity: {
        required
      },
      marks: {
        required
      },
      botanical: {
        required
      }
    }
  },
  methods: {
    async save () {
      console.log(this.form)
      this.$v.form.$touch()
      if (this.$v.form.$error) {
        console.log('error')
      } else {
        const times1 = date.formatDate(addToDate(this.form.date_issue, { days: 1 }), 'YYYY-MM-DD')
        const times2 = date.formatDate(addToDate(this.form.date_treatment, { days: 1 }), 'YYYY-MM-DD')
        this.form.date_issue = times1
        this.form.date_treatment = times2
        this.$q.loading.show()
        if (this.id) {
          this.$api.put('userId/' + this.id, this.form).then(res => {})
        } else {
          this.$api.post('user', this.form).then(res => {})
        }
        this.$q.loading.hide()
        this.$router.go(-1)
      }
    },
    back () {
      this.$router.go(-1)
    },
    async getInfo () {
      this.form = {}
      this.id = this.$route.params.id
      if (this.id) {
        this.$q.loading.show()
        this.$api.get('userId/' + this.id).then(res => {
          this.form = res
          this.$q.loading.hide()
        })
      }
      this.form.plant = 'VENEZUELA'
      this.form.means = 'Rodoviaria'
      this.form.entry = 'SANTA ELENA DE UAIREN - EDO. BOLIVAR'
      this.form.place_of_issue = 'PACARAIMA-RR'
      this.getPlant()
    },
    async getPlant () {
      this.$api.get('plantsList').then(res => {
        this.options = res
        this.$q.loading.hide()
      })
    }
  }
}
</script>
